/* Copyright 2020 Google Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package cmd

import (
	"fmt"

	"github.com/google/gnxi/gnxi_tester/config"
	"github.com/spf13/cobra"
)

var (
	targetsCmd = &cobra.Command{
		Use:     "targets",
		Short:   "Displays target connection history.",
		Example: "gnxi_tester targets",
		Run:     displayTargets,
	}
)

// handleRun will run some or all of the tests.
func displayTargets(cmd *cobra.Command, args []string) {
	targets := config.GetTargets()
	fmt.Printf("%20s%20s%20s%20s\n", "Target Name", "Target Address", "CA", "CA Key")
	for name, target := range targets {
		fmt.Printf("%20s%20s%20s%20s\n", name, target.Address, target.Ca, target.CaKey)
	}
}
